library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity output_valid is
Port (

		valid_in : in std_logic;

		pwm_in : in std_logic_vector(2 downto 0);
		pwm_out : out std_logic_vector(31 downto 0);
		pwm_out_observer : out std_logic_vector(15 downto 0);

		clk_250_mhz: in std_logic
	);
end output_valid;

architecture Behavioral of output_valid is

    signal i_reg_pwm : std_logic_vector(31 downto 0) := (others => '0');
    signal i_reg_pwm_observer : std_logic_vector(15 downto 0) := (others => '0');

begin

    pwm_out <= i_reg_pwm;
    pwm_out_observer <= i_reg_pwm_observer;
    
	MY_PROCESS : process(clk_250_mhz)
	begin
		if rising_edge(clk_250_mhz) then
	       if valid_in = '1' then
		      i_reg_pwm(0) <= pwm_in(0);
		      i_reg_pwm(2) <= pwm_in(1);
		      i_reg_pwm(4) <= pwm_in(2);
		      
		      i_reg_pwm_observer(0) <= pwm_in(0);
		      i_reg_pwm_observer(2) <= pwm_in(1);
		      i_reg_pwm_observer(4) <= pwm_in(2);		      
	       end if;
		end if;
	end process MY_PROCESS;

end Behavioral;
