
wire kernel_monitor_reset;
wire kernel_monitor_clock;
wire kernel_monitor_report;
assign kernel_monitor_reset = ~ap_rst_n;
assign kernel_monitor_clock = ap_clk;
assign kernel_monitor_report = 1'b0;
wire [12:0] axis_block_sigs;
wire [0:0] inst_idle_sigs;
wire [0:0] inst_block_sigs;
wire kernel_block;

assign axis_block_sigs[0] = ~in_Vdc_TDATA_blk_n;
assign axis_block_sigs[1] = ~in_iia_TDATA_blk_n;
assign axis_block_sigs[2] = ~in_iib_TDATA_blk_n;
assign axis_block_sigs[3] = ~in_ii0_TDATA_blk_n;
assign axis_block_sigs[4] = ~in_vca_TDATA_blk_n;
assign axis_block_sigs[5] = ~in_vcb_TDATA_blk_n;
assign axis_block_sigs[6] = ~in_vc0_TDATA_blk_n;
assign axis_block_sigs[7] = ~in_ioa_TDATA_blk_n;
assign axis_block_sigs[8] = ~in_iob_TDATA_blk_n;
assign axis_block_sigs[9] = ~in_io0_TDATA_blk_n;
assign axis_block_sigs[10] = ~in_vrefa_TDATA_blk_n;
assign axis_block_sigs[11] = ~in_vrefb_TDATA_blk_n;
assign axis_block_sigs[12] = ~in_mode_TDATA_blk_n;

assign inst_block_sigs[0] = 1'b0;

assign inst_idle_sigs[0] = 1'b0;

mpc_hls_deadlock_idx0_monitor mpc_hls_deadlock_idx0_monitor_U (
    .clock(kernel_monitor_clock),
    .reset(kernel_monitor_reset),
    .axis_block_sigs(axis_block_sigs),
    .inst_idle_sigs(inst_idle_sigs),
    .inst_block_sigs(inst_block_sigs),
    .block(kernel_block)
);


always @ (kernel_block or kernel_monitor_reset) begin
    if (kernel_block == 1'b1 && kernel_monitor_reset == 1'b0) begin
        find_kernel_block = 1'b1;
    end
    else begin
        find_kernel_block = 1'b0;
    end
end
