#include <hls_stream.h>
#include <stdint.h>
#include "ap_fixed.h"

void abc_ab0(	hls::stream<float>& in_a,
				hls::stream<float>& in_b,
				hls::stream<float>& in_c,
				hls::stream<float>& out_alpha,
				hls::stream<float>& out_beta,
				hls::stream<float>& out_zero)
{

	#pragma HLS INTERFACE axis port=in_a
	#pragma HLS INTERFACE axis port=in_b
	#pragma HLS INTERFACE axis port=in_c
	#pragma HLS INTERFACE axis port=out_alpha
	#pragma HLS INTERFACE axis port=out_beta
	#pragma HLS INTERFACE axis port=out_zero
	#pragma HLS INTERFACE ap_ctrl_none port=return

	const float sqrt3_3 = 0.577332;

	float A = in_a.read();
	float B = in_b.read();
	float C = in_c.read();

	float beta = (B-C)*sqrt3_3;
	float zero = (A+B+C)/3;
	float alpha = A-zero;

	out_alpha.write(alpha);
	out_beta.write(beta);
	out_zero.write(zero);
}
