#include <hls_stream.h>
#include <stdint.h>

void adc_gain(
		hls::stream<int16_t>& in_data,
		hls::stream<float>& in_gain,
		hls::stream<float>& out_data)
{
	#pragma HLS INTERFACE axis port=in_data register_mode=both register
	#pragma HLS INTERFACE axis port=in_gain register_mode=both register
	#pragma HLS INTERFACE axis port=out_data register_mode=both register
	#pragma HLS interface ap_ctrl_none port=return

	float data = (float)in_data.read();
	float gain = in_gain.read();

	out_data.write(data*gain);
}
