#ifndef MPC_H
#define MPC_H

#include <stdint.h>
#include <hls_stream.h>
#include "ap_int.h"

// Ad, Bd, Ad0, Bd0 for sampling frequency = 100kHz
float Ad[2][2] = {{0.9982, -0.0045}, {0.7514, 0.9983}};
float Bd[2][2] = {{0.0045, 0.0017}, {0.0017, -0.7515}};
float Ad0[2][2] = {{0.9303, -0.0044}, {30.2756, 0.9304}};
float Bd0[2][2] = {{0.0044, 0.0696}, {0.0696, -30.2771}};

// numerical constants
const float _1_3 = 0.33333333;
const float _2_3 = 0.66666667;
const float _sqrt3_3 = 0.57735027;

float simulate_state(
                    const float sw[3],
					float Vdc,
					float io_k[2],
					float vref[2],
					float ii_k1[3],
					float vc_k1[3],
					uint32_t mode);

void mpc(	hls::stream<float>& in_Vdc,
			hls::stream<float>& in_iia,
			hls::stream<float>& in_iib,
			hls::stream<float>& in_ii0,
			hls::stream<float>& in_vca,
			hls::stream<float>& in_vcb,
			hls::stream<float>& in_vc0,
			hls::stream<float>& in_ioa,
			hls::stream<float>& in_iob,
			hls::stream<float>& in_io0,
			hls::stream<float>& in_vrefa,
			hls::stream<float>& in_vrefb,
			hls::stream<uint32_t>& in_mode,
			ap_uint<3>& out);

#endif
